#include "Camera.h"

void Camera::validate(int mapWidth, int mapHeight)
{
    if(bounds.x < 0)
        bounds.x = 0;
    else if (bounds.x + bounds.w >= mapWidth)
        bounds.x = mapWidth - bounds.w;
    if(bounds.y < 0)
        bounds.y = 0;
    else if (bounds.y + bounds.h > mapHeight)
        bounds.y = mapHeight - bounds.h;

    ISoundEngine* dj = WubManager::Instance()->getDJ();
    dj -> setListenerPosition(vec3df((bounds.x + bounds.w/2)/SOUNDSCALE, (bounds.y + bounds.h /2)/SOUNDSCALE, 0), vec3df(0,0,1));
}

void Camera::centerOn(Rect center)
{
    bounds.x = center.x + center.w /2 - bounds.w/2;
    bounds.y = center.y + center.h /2 - bounds.h/2;
}

void Camera::scroll(Direction dir, int dist)
{
    switch(dir)
    {
        case LEFT: bounds.x -= dist; break;
        case RIGHT: bounds.x += dist; break;
        case UP: bounds.y -= dist; break;
        case DOWN: bounds.y += dist; break;
    }
}
