#include "Object.h"

Object::Object()
{
    this->sprite = NULL;
    hitbox.x = 0;
    hitbox.y = 0;
    hitbox.w = 0;
    hitbox.h = 0;
    xVel = 0;
    yVel = 0;
    friction = 0;
}

Object::Object(string spritefile)
{
    this->sprite = NULL;
    this->sprite = new Image(spritefile);
    hitbox = sprite->getBounds();
    sprite->getFrameSize(hitbox.w, hitbox.h);
    xVel = 0;
    friction = 0;
    yVel = 0;
}

Object::~Object()
{
    if(sprite)
        delete sprite;
}

void Object::setSprite(string filepath)
{
    if(sprite)
        sprite->setTexture(filepath);
    else
        sprite = new Image(filepath);
}

Rect Object::update()
{
    Rect proposedPosition = hitbox;
    if(xVel > X_TERMINAL_VELOCITY)
        xVel = X_TERMINAL_VELOCITY;
    else if(xVel < -X_TERMINAL_VELOCITY)
        xVel = -X_TERMINAL_VELOCITY;

    if(xVel > Y_TERMINAL_VELOCITY)
        xVel = Y_TERMINAL_VELOCITY;
    else if(xVel < -Y_TERMINAL_VELOCITY)
        xVel = -Y_TERMINAL_VELOCITY;

    proposedPosition.x += xVel / VELOCITY_SCALE;
    proposedPosition.y += yVel / VELOCITY_SCALE;

    if(yVel)
        friction = 0;

    return proposedPosition;
}

Rect Object::getXNudge()
{
    Rect box = hitbox;
    if(xVel < 0)
        box.x--;
    else if(xVel > 0)
        box.x++;

    return box;
}

Rect Object::getYNudge(int nudge)
{
    Rect box = hitbox;
    if(yVel < 0)
        box.y--;
    else if(yVel > 0)
        box.y++;
    else
        box.y+=nudge;

    return box;
}
